%global dlrn_nvr paunch-5.3.2.dev13-0.20200320172309.ebc49c4
%global dlrn 1
%define upstream_version 5.3.2.dev13
%{lua: posix.setenv("RHEL_ALLOW_PYTHON2_FOR_BUILD",1)}
# Macros for py2/py3 compatibility
%if 0%{?fedora} || 0%{?rhel} > 7
%global pyver 3
%else
%global pyver 2
%endif

%global pyver_bin python%{pyver}
%global pyver_sitelib %{expand:%{python%{pyver}_sitelib}}
%global pyver_install %{expand:%{py%{pyver}_install}}
%global pyver_build %{expand:%{py%{pyver}_build}}
# End of macros for py2/py3 compatibility

%{!?upstream_version: %global upstream_version %{version}%{?milestone}}
%global with_doc 0

%global pypi_name paunch

%global common_desc \
Library and utility to launch and manage containers using YAML based configuration data.

Name:       python-%{pypi_name}
Version: 5.3.2
Release: 0.20200320172309.ebc49c4%{?dist}
Summary:    Library and utility to launch and manage containers using YAML based configuration data

License:    ASL 2.0
URL:        http://pypi.python.org/pypi/%{pypi_name}
Source0: paunch-5.3.2.dev13-0.20200320172309.ebc49c4.tar.gz
#
# patches_ignore=DROP-IN-RPM
# patches_base=ebc49c444f2fa3077d60dd79c221a7dcd1f443ec

Source10:   paunch-container-shutdown
Source11:   paunch-container-shutdown.service
Source12:   91-paunch-container-shutdown.preset
Source13:   netns-placeholder.service
Source14:   91-netns-placeholder.preset
Source15:   paunch-start-podman-container

BuildArch:  noarch

%description
%{common_desc}

%package -n python%{pyver}-%{pypi_name}
%{?python_provide:%python_provide python%{pyver}-%{pypi_name}}
Summary:    Library and utility to launch and manage containers using YAML based configuration data

BuildRequires:  python%{pyver}-setuptools
BuildRequires:  python%{pyver}-pbr
BuildRequires:  python%{pyver}-devel
BuildRequires: openstack-macros
# test requires
BuildRequires:  python%{pyver}-cliff
BuildRequires:  python%{pyver}-jmespath
BuildRequires:  python%{pyver}-mock
BuildRequires:  python%{pyver}-oslotest
BuildRequires:  python%{pyver}-psutil
BuildRequires:  python%{pyver}-subunit
BuildRequires:  python%{pyver}-stestr
BuildRequires:  python%{pyver}-tenacity >= 3.2.1

Requires:   python%{pyver}-cliff
Requires:   python%{pyver}-jmespath
Requires:   python%{pyver}-pbr
Requires:   python%{pyver}-tenacity >= 3.2.1
Requires:   python%{pyver}-psutil
Requires:   podman
Requires:   findutils
Requires:   paunch-services

%if %{pyver} == 2
BuildRequires:  PyYAML
Requires:       PyYAML
%else
BuildRequires:  python%{pyver}-PyYAML
Requires:       python%{pyver}-PyYAML
%endif

%description -n python%{pyver}-%{pypi_name}
%{common_desc}

%if 0%{?with_doc}
%package -n python%{pyver}-%{pypi_name}-doc
Summary: Documentation for paunch library and utility

BuildRequires: python%{pyver}-sphinx
BuildRequires: python%{pyver}-openstackdocstheme

%description -n python%{pyver}-%{pypi_name}-doc
%{common_desc}

This package contains auto-generated documentation.
%endif

%package -n python%{pyver}-%{pypi_name}-tests
Summary: Tests for paunch library and utility

Requires:  python%{pyver}-%{pypi_name}
Requires:  python%{pyver}-mock
Requires:  python%{pyver}-oslotest
Requires:  python%{pyver}-subunit
Requires:  python%{pyver}-stestr
Requires:  python%{pyver}-tenacity >= 3.2.1

%description -n python%{pyver}-%{pypi_name}-tests
%{common_desc}

This package contains library and utility tests.

%package -n paunch-services
Summary: Services related to paunch
BuildRequires:  systemd-units
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
Requires: iproute

%description -n paunch-services
This package contains service definitions related to paunch


%prep
%setup -q -n %{pypi_name}-%{upstream_version}

# Let's handle dependencies ourseleves
%py_req_cleanup

%build
%pyver_build

%install
%pyver_install

# Install shutdown script
install -p -D -m 755 %{SOURCE10} %{buildroot}%{_libexecdir}/paunch-container-shutdown

# Install podman start script
install -p -D -m 755 %{SOURCE15} %{buildroot}%{_libexecdir}/paunch-start-podman-container

# Install systemd units
install -p -D -m 644 %{SOURCE11} %{buildroot}%{_unitdir}/paunch-container-shutdown.service

# Install systemd preset
install -p -D -m 644 %{SOURCE12} %{buildroot}%{_presetdir}/91-paunch-container-shutdown.preset

# Install netns unit
install -p -D -m 644 %{SOURCE13} %{buildroot}%{_unitdir}/netns-placeholder.service

# Install systemd preset for netns unit
install -p -D -m 644 %{SOURCE14} %{buildroot}%{_presetdir}/91-netns-placeholder.preset

%if 0%{?with_doc}
# generate html docs
%{pyver_bin} setup.py build_sphinx
# remove the sphinx-build leftovers
rm -rf doc/build/html/.{doctrees,buildinfo}
%endif

%check
PYTHON=python%{pyver} %{pyver_bin} setup.py test

%post -n paunch-services
%systemd_post paunch-container-shutdown.service
%systemd_post netns-placeholder.service

%preun -n paunch-services
%systemd_preun paunch-container-shutdown.service
%systemd_preun netns-placeholder.service

%files -n python%{pyver}-%{pypi_name}
%doc README.rst
%license LICENSE
%{_bindir}/%{pypi_name}
%{pyver_sitelib}/%{pypi_name}*
%exclude %{pyver_sitelib}/%{pypi_name}/tests

%if 0%{?with_doc}
%files -n python%{pyver}-%{pypi_name}-doc
%doc doc/build/html
%license LICENSE
%endif

%files -n python%{pyver}-%{pypi_name}-tests
%license LICENSE
%{pyver_sitelib}/%{pypi_name}/tests

%files -n paunch-services
%license LICENSE
%{_libexecdir}/paunch-container-shutdown
%{_libexecdir}/paunch-start-podman-container
%{_unitdir}/paunch-container-shutdown.service
%{_presetdir}/91-paunch-container-shutdown.preset
%{_unitdir}/netns-placeholder.service
%{_presetdir}/91-netns-placeholder.preset

%changelog
* Fri Mar 20 2020 OSP Prod Chain <dev-null@redhat.com> 5.3.1-1
- Update patches
- Do not set cpuset-cpus if cconfig['cpuset_cpus'] == 'all'

* Wed Mar 18 2020 OSP Prod Chain <dev-null@redhat.com> 5.3.1-1
- Update patches
- Don't set cpuset_cpus if empty

* Tue Mar 10 2020 OSP Prod Chain <dev-null@redhat.com> 5.3.1-1
- Update patches
- Cleanup containers in the same loop as they are created

* Sat Feb 29 2020 OSP Prod Chain <dev-null@redhat.com> 5.3.1-1
- Update patches
- Fallback to a rm -f action for podman

* Fri Feb 21 2020 OSP Prod Chain <dev-null@redhat.com> 5.3.1-1
- Update patches

* Tue Feb 18 2020 OSP Prod Chain <dev-null@redhat.com> 5.3.1-1
- Update patches
- Allow to not cleanup containers that aren't in config

* Sat Feb 08 2020 OSP Prod Chain <dev-null@redhat.com> 5.3.1-1
- Update patches
- load_config: allow the config to be overriden

* Thu Jan 30 2020 OSP Prod Chain <dev-null@redhat.com> 5.3.1-1
- Update patches
- Do not force remove containers

* Tue Jan 28 2020 OSP Prod Chain <dev-null@redhat.com> 5.3.1-1
- Update patches
- Merge "Add missing ExecReload in container service unit file" into stable/train
- Add missing ExecReload in container service unit file
- Execute healthchecks as root

* Wed Jan 22 2020 OSP Prod Chain <dev-null@redhat.com> 5.3.1-1
- Update patches
- Return an error if tripleo-ansible deployed containers

* Fri Jan 10 2020 OSP Prod Chain <dev-null@redhat.com> 5.3.1-1
- Update patches
- Fix backward compatibility for old config startup files

* Tue Jan 07 2020 OSP Prod Chain <dev-null@redhat.com> 5.3.1-1
- Update patches
- Add SyslogIdenfier to healthcheck systemd unit

* Sat Dec 14 2019 OSP Prod Chain <dev-null@redhat.com> 5.3.0-1
- Update patches
- builder: include environment when running an exec

* Wed Dec 11 2019 OSP Prod Chain <dev-null@redhat.com> 5.3.0-1
- Update patches
- Exit 1 if a container fails and return the error

* Fri Dec 06 2019 OSP Prod Chain <dev-null@redhat.com> 5.3.0-1
- Update patches
- Merge "Make containerized-undercloud-upgrades vote on train" into stable/train
- Make containerized-undercloud-upgrades vote on train

* Fri Dec 06 2019 OSP Prod Chain <dev-null@redhat.com> 5.3.0-1
- Update patches

* Thu Dec 05 2019 OSP Prod Chain <dev-null@redhat.com> 5.3.0-1
- Update patches
- Do not always needlessly pull the images via podman

* Mon Dec 02 2019 OSP Prod Chain <dev-null@redhat.com> 5.3.0-1
- Update patches
- Merge "Fix action Apply ignoring managed-by arg" into stable/train
- Fix action Apply ignoring managed-by arg

* Tue Oct 22 2019 OSP Prod Chain <dev-null@redhat.com> 5.3.0-1
- Update patches
- Update TOX/UPPER_CONSTRAINTS_FILE for stable/train
- Update .gitreview for stable/train

* Wed Oct 16 2019 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- list_or_dict_arg: fix the else condition

* Wed Oct 09 2019 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- builder: allow to pass a dict to 'environment'

* Thu Oct 03 2019 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Properly mock cpu_affinity on all unit tests

